dofile("scripts/base/util.lua")

function query_to_table(str)
	local tbl = {}
	for a, b in string.gmatch(str, "([a-z]+)=([A-Za-z0-9]+)") do
		tbl[a] = b
	end
	return tbl
end

params = query_to_table(query)
requestparams = query_to_table(requestquery)

local processors = {}
local printers = {}

function add_processor(file, func)
	if not processors[file] then processors[file] = {} end
	table.insert(processors[file], func)
end

function add_printer(file, func)
	if not printers[file] then printers[file] = {} end
	table.insert(printers[file], func)
end

noncombat_choice_texts = {}

function add_choice_text_conditional(title, tbl, test)
	if not noncombat_choice_texts[title] then noncombat_choice_texts[title] = {} end
	table.insert(noncombat_choice_texts[title], { test = test, table = tbl })
end

function add_choice_text(title, tbl)
	add_choice_text_conditional(title, tbl, function() return true end)
end

dofile("scripts/base/custom-combat-skills.lua")

function load_file(category, name)
	if category ~= "chat" then
		dofile("scripts/"..name)
	end
end

if path == "/charpane.php" then
	familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0></a><br>([0-9]+) lbs")
	if not familiar_picture then
		familiar_picture, familiar_weight = string.match(text, "<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/([^\"]-).gif\" width=30 height=30 border=0>.- <b>([0-9]+)</b> pound ")
	end
end

add_printer("/charpane.php", function()
	text = string.gsub(text, "(<td align=right>Meat:.-)(</table>)", "%1<!-- charpane compact text space -->%2")
	text = string.gsub(text, "(src=\"http://images.kingdomofloathing.com/itemimages/hourglass.gif\".-</table>.-<br>)", "%1<!-- charpane normal text space -->")

	text = string.gsub(text, "(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0></a><br>)([0-9]+)( lbs..-)(</center>)", "%1%2%3%4%5<!-- charpane compact familiar text space type{%2} weight{%4} -->%6")
	text = string.gsub(text, "(<a target=mainpane href=\"familiar.php\" class=\"familiarpick\"><img src=\"http://images.kingdomofloathing.com/itemimages/)([^\"]-)(.gif\" width=30 height=30 border=0>.- <b>)([0-9]+)(</b> pound .-)(</table></center>)", "%1%2%3%4%5<!-- charpane normal familiar text space type{%2} weight{%4} -->%6")
end)

dofile("scripts/loaders.lua")

if not active then
	if requestpath == "/adventure.php" then
		zone = string.match(requestquery, "snarfblat=([0-9]+)")
-- 		print("setting zone", zone)
		if (zone) then
			set_fight_state("zone", tonumber(zone))
		end
	end
end




combat_round = tonumber(string.match(text, "var onturn = ([0-9]+);"))
monster_name = string.match(text, "<span id='monname'>(.-)</span>")
if path == "/fight.php" then
	local z = get_fight_state("zone")
	if z ~= "" then
		adventure_zone = tonumber(z)
	end
end

awesome_monsters = {
	[" Bob Racecar"] = "ketchup hound",
	["a gaudy pirate"] = "snakehead charrrm",
	["some zombie waltzers"] = "dance card",
	["a blur"] = "drum machine",
	["a rampaging adding machine"] = "64735 scroll",
	["a cleanly pirate"] = "rigging shampoo",
	["a creamy pirate"] = "ball polish",
	["a curmudgeonly pirate"] = "mizzenmast mop",
}

-- yossarian's tools / gremlins
if path == "/fight.php" then
	if get_fight_state("gremlin.type") ~= "no tool" then
		if adventure_zone == 182 then
			awesome_monsters["a batwinged gremlin"] = "molybdenum hammer"
		elseif adventure_zone == 184 then
			awesome_monsters["an erudite gremlin"] = "molybdenum crescent wrench"
		elseif adventure_zone == 183 then
			awesome_monsters["a spider gremlin"] = "molybdenum pliers"
		elseif adventure_zone == 185 then
			awesome_monsters["a vegetable gremlin"] = "molybdenum screwdriver"
		end
	end
end

add_printer("/shore.php", function()
	local needed = get_ascension_state("zone.lair.itemsneeded")
	if (needed ~= "") then
		local tbl = str_to_table(needed)

		local toweritems = {
			["stick of dynamite"] = "Distant Lands Dude Ranch Adventure",
			["tropical orchid"] = "Tropical Paradise Island Getaway",
			["barbed-wire fence"] = "Large Donkey Mountain Ski Resort",
		}

		for from, to in pairs(tbl) do
			if (toweritems[to]) then
				dest = toweritems[to]
				text = text.gsub(text, "(<td valign=center>)("..dest..")(</td>)", "%1<b>%2</b>%3")
			end
		end
	end
end)

add_processor("/fight.php", function()
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire an item: <b>([^<]+)</b></td></tr></table></center>"
	for alt, title, item in string.gmatch(text, pattern) do
		print("item drop", alt, title, 1, item)
	end
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire <b>([0-9]+) ([^<]+)</b></td></tr></table></center>"
	for alt, title, amount, item in string.gmatch(text, pattern) do
		print("item drop", alt, title, amount, item)
	end
	pattern = "<center><table class=\"item\" style=\"float: none\" rel=\"[^\"]*\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"([^\"]*)\" title=\"([^\"]*)\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>You acquire <b>(11) ([^<]+)</b><br>%(That's ridiculous.  It's not even funny.%)</td></tr></table></center>"
	for alt, title, amount, item in string.gmatch(text, pattern) do
		print("item drop", alt, title, amount, item)
	end
end)

add_printer("/fight.php", function()
	pattern = "(<center><Table><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/mp.gif\" height=30 width=30></td><td valign=center class=effect>)(You gain )([0-9]+)( M[a-z]+ Points.)(</td></tr></table></center>)"
	text = string.gsub(text, pattern, "%1<span style=\"color: darkblue\">%2%3%4</span>%5")

	pattern = "(<center><table><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/hp.gif\" height=30 width=30></td><td valign=center class=effect>)(You gain )([0-9]+)( hit points.)(</td></tr></table></center>)"
	text = string.gsub(text, pattern, "%1<span style=\"color: darkred\">%2%3%4</span>%5")

	text = string.gsub(text, "(<center><table class=\"item\" style=\"float: none\" rel=\")([^\"]*)(\"><tr><td><img src=\"http://images.kingdomofloathing.com/itemimages/[^\"]+.gif\" alt=\"[^\"]*\" title=\"[^\"]*\" class=hand onClick='descitem%([0-9]+%)'></td><td valign=center class=effect>)(You acquire .-)(</td></tr></table></center>)", function (pre, rel, mid, dropinfo, post)
-- 		print("item capture", pre, rel, mid, dropinfo, post)
		local msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span>" .. post
		if string.match(rel, "u=u") then
-- 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [use]" .. post
-- 			http://localhost:18481/inv_use.php?pwd=xxx&which=3&whichitem=3236
		elseif string.match(rel, "u=q") then
-- 			msg = pre .. rel .. mid .. "<span style=\"color: darkgreen\">" .. dropinfo .. "</span> [equip]" .. post
-- 			http://localhost:18481/inv_equip.php?pwd=xxx&which=2&action=equip&whichitem=2813
		end
		return msg
	end)
end)


add_printer("/fight.php", function()
	pattern = "(<b>)(Combat)(!</b>)"
	text = string.gsub(text, pattern, "%1%2 round " .. tostring(combat_round) .. "%3")

	local color = "darkslategray"
	local extra = ""
	if awesome_monsters[monster_name] then
		color = "royalblue"
		extra = "<br><center style=\"font-size: 75%%; color: green\">[" .. awesome_monsters[monster_name] .. "]</center>"
	end

	pattern = "(<span id='monname')(>)([^<]+)(</span>)"
	text = string.gsub(text, pattern, "%1 style=\"color: "..color.."\"%2(%3)%4" .. extra)
end)

add_processor("/account_contactlist.php", function ()
	local contacts = {}
	for a, b in string.gmatch(text, "<td><a href=\"showplayer%.php%?who=([0-9]-)\" class=nounder><b>(.-)</b></a></td>") do
		contacts[a] = b
	end
	set_character_state("kol.account.contact list", table_to_str(contacts))
end)

add_processor("/account_chatcolors.php", function ()
	local contact_color_options = string.match(text, "<td>Your contacts:</td><td><select name=chatcolorcontacts>(.-)</select>")
	if contact_color_options then
		local selected = string.match(contact_color_options, "<option value=[0-9]- selected>([^<]-)</option>")
		if selected then
			set_character_state("kol.account.contact chat color", selected)
		end
	end
end)


add_printer("/choice.php", function ()
	text = string.gsub(text, "<a href=\"adventure.php%?snarfblat=([0-9]+)\">Adventure [^<]+</a>", "%0 <a href=\"automate-zone?id=%1&amp;times=10\" style=\"color:green\">{automate 10}</a><a href=\"automate-zone?id=%1&amp;times=50\" style=\"color:green\">{50}</a><a href=\"automate-zone?id=%1&amp;times=1\" style=\"color:green\">{1}</a><script language=\"javascript\">function automate_N_turns(url) { N = prompt('How many turns?'); if (N > 0) { top.mainpane.location.href = (url + N); } } </script><a href=\"javascript:automate_N_turns('automate-zone?id=%1&amp;times=')\" style=\"color:green\">{N}</a>")
end)

add_printer("/adventure.php", function ()
	text = string.gsub(text, "<a href=\"adventure.php%?snarfblat=([0-9]+)\">Adventure [^<]+</a>", "%0 <a href=\"automate-zone?id=%1&amp;times=10\" style=\"color:green\">{automate 10}</a><a href=\"automate-zone?id=%1&amp;times=50\" style=\"color:green\">{50}</a><a href=\"automate-zone?id=%1&amp;times=1\" style=\"color:green\">{1}</a><script language=\"javascript\">function automate_N_turns(url) { N = prompt('How many turns?'); if (N > 0) { top.mainpane.location.href = (url + N); } } </script><a href=\"javascript:automate_N_turns('automate-zone?id=%1&amp;times=')\" style=\"color:green\">{N}</a>")
end)

add_printer("/fight.php", function ()
	text = string.gsub(text, "<a href=\"adventure.php%?snarfblat=([0-9]+)\">Adventure [^<]+</a>", "%0 <a href=\"automate-zone?id=%1&amp;times=10\" style=\"color:green\">{automate 10}</a><a href=\"automate-zone?id=%1&amp;times=50\" style=\"color:green\">{50}</a><a href=\"automate-zone?id=%1&amp;times=1\" style=\"color:green\">{1}</a><script language=\"javascript\">function automate_N_turns(url) { N = prompt('How many turns?'); if (N > 0) { top.mainpane.location.href = (url + N); } } </script><a href=\"javascript:automate_N_turns('automate-zone?id=%1&amp;times=')\" style=\"color:green\">{N}</a>")
end)

add_printer("/ocean.php", function ()
	text = string.gsub(text, "<a href=\"adventure.php%?snarfblat=([0-9]+)\">Adventure [^<]+</a>", "%0 <a href=\"automate-zone?id=%1&amp;times=10\" style=\"color:green\">{automate 10}</a><a href=\"automate-zone?id=%1&amp;times=50\" style=\"color:green\">{50}</a><a href=\"automate-zone?id=%1&amp;times=1\" style=\"color:green\">{1}</a><script language=\"javascript\">function automate_N_turns(url) { N = prompt('How many turns?'); if (N > 0) { top.mainpane.location.href = (url + N); } } </script><a href=\"javascript:automate_N_turns('automate-zone?id=%1&amp;times=')\" style=\"color:green\">{N}</a>")
end)

add_printer("/fight.php", function ()
	text = string.gsub(text, "<center><a href=\"inv_use.php%?pwd=[0-9a-f]+&whichitem=2328\">Use another drum machine</a>", "%0 <a href=\"automate-sandworms?times=10\" style=\"color:green\">{automate 10}</a><a href=\"automate-sandworms?times=50\" style=\"color:green\">{50}</a><a href=\"automate-sandworms?times=1\" style=\"color:green\">{1}</a><script language=\"javascript\">function automate_N_turns(url) { N = prompt('How many turns?'); if (N > 0) { top.mainpane.location.href = (url + N); } } </script><a href=\"javascript:automate_N_turns('automate-sandworms?times=')\" style=\"color:green\">{N}</a>")
end)

fight_is_over = nil
if path == "/fight.php" then
	if (string.match(text, "state%['fightover'%] = true;")) then
		fight_is_over = true
	else
		fight_is_over = false
	end
end

if active then
	for _, f in pairs(printers[path] or {}) do
		local sas = set_ascension_state
		local sfs = set_fight_state
		set_ascension_state = nil
		set_fight_state = nil
		f()
		set_ascension_state = sas
		set_fight_state = sfs
	end
else
	for _, f in pairs(processors[path] or {}) do
		local realtext = text
		f()
		text = realtext
	end
end

if path == "/fight.php" then
	dofile("scripts/base/fight-page.lua")
end

if not active and fight_is_over == true then
	reset_fight_state()
end

dofile("scripts/zones/rats.lua")

if active and path == "/charpane.php" then
	print_charpane_lines()
end

--~ if path ~= "/charpane.php" then
--~ 	print(text)
--~ end

return text
